//  Copyright © 2012 Stephen Smally
//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 2 of the License, or
//      (at your option) any later version.
//      
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//      
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
//      MA 02110-1301, USA.
//      

using Gtk;

namespace Lsc.Widgets {
    public class InfoMessage : InfoBar {
        // Signals
        public signal void choosed ();
        
        // Widgets
        public Label text;
        public Button info_button;
        public Button action_button;
        
        // Vars
        private PackageKit.Package pkg;
        
        public enum ResponseId {
            INFO,
            INSTALL
        }
        
        public void update (string pkg_name) {
            stdout.printf("%s\n", pkg_name);
            pkg.set_id(pkg_name);
            no_show_all = false;
            show_all();
            text.set_label(@"Selected package <b>$(pkg.get_name())</b>");
        }
        
        public InfoMessage () {
            message_type = MessageType.INFO;
            ((Box) get_action_area()).orientation = Orientation.HORIZONTAL;
            Box main = get_content_area() as Box;
            main.orientation = Orientation.HORIZONTAL;
            main.spacing = 2;
            orientation = Orientation.HORIZONTAL;
            
            text = new Label("");
            text.use_markup = true;
            text.ellipsize = Pango.EllipsizeMode.END;
            
            add_button(Stock.INFO, ResponseId.INFO);
            add_button("Install", ResponseId.INSTALL);
            
            focus_out_event.connect(() => {
                set_visible(false);
                return false;
            });
            
            main.pack_start(text, false, false, 0);
            no_show_all = true;
            
            pkg = new PackageKit.Package();
        }
    }
}
