//
//  Copyright © 2012 Stephen Smally
//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 2 of the License, or
//      (at your option) any later version.
//      
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//      
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
//      MA 02110-1301, USA.
//      

using Gtk;

namespace Lsc.Widgets {
    public class MainToolbar : Toolbar {
        // Widgets
        private ToolItem tool;
        public Button back;
        public Button label;
        public SearchBar searchbar;
        
        public void update_label (Notebook nb, Widget pg, uint page_n) {
            label.label = ((PageType) page_n).to_string();
        }
        
        private void insert_with_tool (Widget widget, int pos) {
            tool = new ToolItem();
            tool.add(widget);
            insert(tool, pos);
        }
        
        public MainToolbar () {
            get_style_context().add_class("primary-toolbar");
            
            toolbar_style = ToolbarStyle.BOTH_HORIZ;
            show_arrow = false;
            
            Box button_b = new Box(Orientation.HORIZONTAL, 0);
            
            back = new Button();
            back.image = new Image.from_stock(Stock.GO_BACK, IconSize.BUTTON);
            back.can_focus = false;
            label = new Button.with_label(PageType.HOMEPAGE.to_string());
            label.can_focus = false;
            label.valign = Align.CENTER;
            label.vexpand = false;
            back.valign = Align.CENTER;
            back.vexpand = false;
            
            button_b.pack_start(back, false, false, 0);
            button_b.pack_start(label, false, false, 0);
            insert_with_tool(button_b, -1);
            
            ToolItem space_item = new ToolItem();
            space_item.set_expand(true);
            insert(space_item, -1);
            
            searchbar = new SearchBar("Search apps...");
            searchbar.text_changed_pause.connect((text) => {stdout.printf("%s\n", text); });
            searchbar.margin = 5;
            insert_with_tool(searchbar, -1);
        }
    }
}

